#!/bin/bash
#
# Copyright 2014 Aeneas Jaissle <aj@ajaissle.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 or, at your option, any later version
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin street, Fifth Floor, Boston, MA 02111-1301, USA.
#

if   [[ "$1" == "" ]]; then
    echo "Backing up /etc/kolab..."
    tar cjvf $(hostname)-etc-kolab_$(date --rfc-3339=date).tar.bz2 \
        --exclude=*.rpmnew \
        --exclude=*.rpmsave \
        /etc/kolab
    echo "Exit Code:" $?
    
elif [[ "$1" == "--restore" ]]; then
    while : ; do
        if   [[ "$2" == "" ]]; then
            read -p "File to restore from: " input
        else
            if [[ -f "$2" ]]; then
                echo "Using $2 as restore source"
                input="$2"
            else
                echo "Please supply a valid and accessible backup file to restore from."
                read -p "File to restore from: " input
            fi
        fi
        if [[ -f "$input" ]]; then
            break
        fi
    done

    tar xjvf $input -C /
    echo "Exit Code: $?"
else
    echo "Option not recognized: $1"
fi
