#!/bin/bash
#
# Copyright 2014 Aeneas Jaissle <aj@ajaissle.de>
# Copyright 2013 Kolab Systems AG
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 3 or, at your option, any later version
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin street, Fifth Floor, Boston, MA 02111-1301, USA.
#

if   [[ "$1" == "" ]] || [["$1" == "--before" ]]; then
    echo "Backing up /var/lib/dirsrv..."
    for dir in `find /etc/dirsrv/ -mindepth 1 -maxdepth 1 -type d -name "slapd-*" | xargs -n 1 basename`; do
        for nsdb in `find /var/lib/dirsrv/${dir}/db/ -mindepth 1 -maxdepth 1 -type d | xargs -n 1 basename`; do
            ns-slapd db2ldif -D /etc/dirsrv/${dir} -n ${nsdb} -a /tmp/$(hostname)-$(echo ${dir} | sed -e 's/slapd-//g')-${nsdb}_$(date --rfc-3339=date).ldif >/dev/null 2>&1
            echo "Exit Code: $?"
        done
    done
    chown kolab:kolab /tmp/*_$(date --rfc-3339=date).ldif
elif [[ "$1" == "--restore" ]]; then
    echo "Not implemented, yet"
elif [[ "$1" == "--after" ]]; then
    rm -rf /tmp/*.ldif
    echo "Exit Code: $?"
else
    echo "Option not recognized: $1"
fi
